unit sp_Lib_Delphi_1Cv7;
interface
(*
  -   :
     "Delphi  1:.  "
*)

Uses
  //__IO,
  sp_Lib_Delphi,
  Dialogs,
  Consts,
  ComObj,
  FileCtrl,
  registry,
  classes,
  windows,
  SysUtils;


Const
  //-----------------------------------
  //1C
  NameLinksTMP = 'Links.tmp'; // ,       1
  SubDir_SYSLOG = 'SYSLOG\'; // ,    NameLinksTMP
  //-----------------------------------



// 1: v7    OLE Automation
function ConnectTo1C(InitStr,NoSplashShow : string) : Variant;

//    1   
function Load_ListDB_from_Registry(KeyName : string;
                                   List : TStrings;
                                   YesDetect_1Cv7md : boolean) : integer;

//    1
function Get_List_ActiveUsers_from_1C(DirTMP,
                                      fn_Links_TMP : string;
                                      ListUsers : TStrings;
                                      YesCopyToDirTMP : boolean) : integer;
//     1 -  
function Exctract_UserName_from_ListActiveUsers(ListUsers : TStrings) : integer;




implementation


//***************************************************************
function ConnectTo1C(InitStr,NoSplashShow : string) : Variant;
// 1:    OLE Automation
Var
  ResOpen : integer;
begin
  Result:=UnAssigned;
  InitStr:=Trim(InitStr);
  Result := CreateOleObject('V77.Application');
  if YesLinkToVariant(Result) then begin
     ResOpen:=Result.Initialize(Result.RMTrade, InitStr, NoSplashShow);
     if ResOpen>=0 then begin
        Result:=UnAssigned;
     end;
  end;
end;
//***************************************************************




function Load_ListDB_from_Registry(KeyName : string;
                                   List : TStrings;
                                   YesDetect_1Cv7md : boolean) : integer;
//    1   
//KeyName -     ,
//  .
// Windows-2000/XP :
//  KeyName= Software\1C\1CV7\7.7\Titles
//  RootKey= HKey_Current_User
//List -      1
//YesDetect_1Cv7md -  TRUE,     1Cv7.md
var
  sNameDB,  //  ( ) 1
  fnMD : string; //   1Cv7.MD
  Reg  : TRegistry;
  i    : integer;
  Yes  : byte;
begin
  Result:=0;
  if List<>NIL then begin
     List.Clear;
     KeyName:=Trim(KeyName);
     if length(KeyName)>0 then begin
        Reg:=TRegistry.Create;
        try
          Reg.RootKey:=HKey_Current_User;

          if Reg.OpenKey(KeyName,False) then begin

             //    
             //( ) 1
             Reg.GetValueNames(List);

             if List.Count>0 then begin
                //---------------------------------
                //    1
                i:=-1;
                while i<(List.Count-1) do
                 begin
                   i:=i+1;
                   Yes  := 0;
                   if YesDetect_1Cv7md then begin
                      //   1Cv7.md
                      //  

                      //   MD- 
                      fnMD := List[I]+'1cv7.md';
                      //,   MD-
                      if FileExists(fnMD) then begin
                         //MD- 
                         Yes:=1;
                      end
                      else begin
                         //MD-  ,   
                         List.Delete(i);
                         i:=i-1;
                      end;

                   end
                   else begin
                      //    1Cv7.md
                      Yes:=1;
                   end;
                   if Yes>0 then begin
                      //   
                      sNameDB:=Trim(Reg.ReadString(List[I]));
                      List[i]:=sNameDB+'='+List[i];
                   end;
                   //Application.ProcessMessages;
                end;
                //---------------------------------

             end;
          end;
          Result:=List.Count;
        finally
          Reg.Free;
        end;
     end;
  end;
end;




function Get_List_ActiveUsers_from_1C(DirTMP,
                                      fn_Links_TMP : string;
                                      ListUsers : TStrings;
                                      YesCopyToDirTMP : boolean) : integer;
//    1
//DirTMP -     
//( )
//fn_Links_TMP -    "Links.tmp"
//(   1)
//ListUsers -   
//(    SDF-)
//YesCopyToDirTMP -  TRUE,  links.tmp   DirTMP
Var
  fn_Links_TMP_X : string;
  fHandle : THandle;
  i : integer;
  Sx : string;
  YesNext : byte;
  List : TStrings;

begin
 Result:=0;
 YesNext := 0;
 if ListUsers<>NIL then begin
   ListUsers.Clear;

   //   
   List := TStringList.Create;
   TRY

    fn_Links_TMP_X:=fn_Links_TMP;

    if YesCopyToDirTMP then begin
       DirTMP:=Trim(DirTMP);
       if length(DirTMP)>0 then begin
          if DirTMP[length(DirTMP)]<>'\' then DirTMP:=DirTMP+'\';
          //   <DirTMP>
          if DirectoryExists(DirTMP) then begin
             //   <Links.tmp>,
             //   
             if FileExists(fn_Links_TMP) then begin
               //   ()  <Links.tmp>,
               //   
               fn_Links_TMP_X:=DirTMP+ExtractFileName(fn_Links_TMP);
               //   <Links.tmp>   <DirTMP>
               if Windows.CopyFile(PCHAR(fn_Links_TMP),
                                  PCHAR(fn_Links_TMP_X),
                                  FALSE) then begin
                  YesNext := 1;
               end;
             end;
          end;
       end;
    end
    else begin
       //   <Links.tmp>,
       //   
       if FileExists(fn_Links_TMP_X) then begin
          YesNext := 1;
       end;
    end;

    if YesNext>0 then begin
       //  <Links.tmp>   <DirTMP>  <List>
       //List.LoadFromFile(fn_Links_TMP_X);
       LoadFromFileToStrings(fn_Links_TMP_X,List);

       if List.Count>0 then begin

         //----------------------------
         //  "" ,   
         i:=-1;
         while i<(List.Count-1) do
          begin
          i:=i+1;
          if POS('{"Name"',List[i])<>1 then begin
            List.Delete(i);
            i:=i-1;
           end;
         end;
         //----------------------------


         if List.Count>0 then begin
           //,    
           YesNext := 1;
         end;

       end;
    end;

    if YesNext>0 then begin
      //  Links.tmp
      fHandle:=Windows.CreateFile(PCHAR(fn_Links_TMP),
                          GENERIC_READ or GENERIC_WRITE,
                          FILE_SHARE_READ OR FILE_SHARE_WRITE,
                          {NIL} 0,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL {0},
                          0);
      TRY

       //------------------------
       //  
       i:=-1;
       while i<(List.Count-1) do
        begin
        i:=i+1;
        //     Links.tmp,
        //  
        if not (LockFile(fHandle, $1E8481+i{-1}, 0, 1, 0)) then begin
          //  -    
          ListUsers.Add(List[i]);
        end
        else begin
          //  -     .
          // 
          UnLockFile(fHandle, $1E8481+i{-1}, 0, 1, 0);
        end;
        //Application.ProcessMessages;
       end;
       //------------------------

       //   
       Result:=ListUsers.Count;

      FINALLY
       // 
       Windows.CloseHandle(fHandle);
      END;

    end;

   FINALLY
    // 
    if List<>NIL then begin
       List.Clear;
       List.Free;
       List:=NIL;
    end;
   END;
 end;
end;


function Exctract_UserName_from_ListActiveUsers(ListUsers : TStrings) : integer;
//     1, 
//    Get_List_ActiveUsers_from_1C,
// 
Var
  List : TStrings;
  i : integer;
  sNameUser : string;

begin
  Result:=0;
  if ListUsers<>NIL then begin
     if ListUsers.Count>0 then begin
        List := TStringList.Create;
        TRY
          //  
          for i:=0 to (ListUsers.Count-1) do
           begin
            //    
            sp_Convert_SDF_to_List(ListUsers[i],List,'{} ');
            //  "" "" -   
            sNameUser:=GetValueFromList(2,List);
            if length(sNameUser)<=0 then sNameUser:='<noname>';
            ListUsers[i]:=sNameUser;
          end;
          Result:=ListUsers.Count;
        FINALLY
         // 
         if List<>NIL then begin
            List.Clear;
            List.Free;
            List:=NIL;
         end;
        END;
     end;
  end;
end;


end.






